package ru.ulstu.paper.controller;

import org.springframework.web.bind.annotation.*;
import ru.ulstu.configuration.Constants;
import ru.ulstu.core.model.response.Response;
import ru.ulstu.paper.model.Paper;
import ru.ulstu.paper.model.PaperDto;
import ru.ulstu.paper.service.PaperService;

import java.io.IOException;
import java.util.List;

import static ru.ulstu.paper.controller.PaperController.URL;

@RestController
@RequestMapping(URL)
public class PaperController {
    public static final String URL = Constants.API_1_0 + "papers";

    private final PaperService paperService;

    public PaperController(PaperService paperService) {
        this.paperService = paperService;
    }

    @GetMapping
    public Response<List<PaperDto>> getPapers() {
        return new Response<>(paperService.findAll());
    }

    @PostMapping
    public Response createPaper(@RequestBody PaperDto paperDto) throws IOException {
        return new Response(paperService.create(paperDto));
    }

    @PutMapping
    public Response updatePaper(@RequestBody PaperDto paperDto) throws IOException {
        return new Response(paperService.update(paperDto));
    }

    @DeleteMapping("/{paper-id}")
    public Response delete(@PathVariable("paper-id") Integer paperId) throws IOException {
        paperService.delete(paperId);
        return new Response(true);
    }
}
